
# schnelles Finden des ggT
def ggT(a, b):
    while b != 0:
        tmp = a
        a = b
        b = tmp%b
    return a

def ggTr(a, b):
    if (b == 0):
        return a
    else:
        return ggTr(b, a%b)


# Vielfachsummendarstellung des ggT
# Lemma von Bezout
def vielfachsumme(a, b):
    if (b == 0):
        return (a, 1, 0)
    else:
        ggT, s, t = vielfachsumme(b, a%b)
    return ggT, t, s - (a/b)*t

# modulares Inverses mit dem Lemma von Bezout
def modinv(a, n):
    ggT, s, t = vielfachsumme(a, n)
    if (ggT > 1):
        return -1
    if (s < 0):
        s = s + n
    return s

# schnelles Potenzieren: square and multiply
def pot(x, y):
    n = 0
    potenz = 1
    while (y > 0):
        if (y%2 == 1):
            potenz = potenz*x
            y = y - 1
        else:
            y = y/2
            x = x*x
        n += 2
    return (potenz, n)


# schnelles modulares Potenzieren
def modpot(x, y, n):
    potenz = 1
    while (y > 0):
        if (y%2 == 1):
            potenz = (potenz*x)%n
            y = y - 1
        else:
            x = (x*x)%n
            y = y/2
    return potenz
















